   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE

   MAP
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('OTHER001.CLW')
BrowseWAGES            PROCEDURE   !Browse the WAGES File
     END
     MODULE('OTHER002.CLW')
UpdateWAGES            PROCEDURE   !Update the WAGES File
     END
    ! Declare functions defined in this DLL
other:Init             PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>)
other:Kill             PROCEDURE
   END

SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

!region File Declaration
WAGES                FILE,DRIVER('MSSQL'),PRE(wag),BINDABLE,CREATE,THREAD,EXTERNAL(''),DLL(dll_mode) !                     
PK_Wages                 KEY(wag:WagesID),NOCASE,PRIMARY   !                     
Key_Department           KEY(wag:Department),DUP,NOCASE    !                     
Record                   RECORD,PRE()
WagesID                     LONG                           !                     
Employee                    STRING(30)                     !                     
Department                  STRING(30)                     !                     
Salary                      DECIMAL(9,2)                   !                     
Other                       STRING(21)                     !                     
                         END
                     END                       

!endregion

Access:WAGES         &FileManager,THREAD,EXTERNAL,DLL      ! FileManager for WAGES
Relate:WAGES         &RelationManager,THREAD,EXTERNAL,DLL  ! RelationManager for WAGES

GlobalRequest        BYTE,EXTERNAL,DLL,THREAD              ! Exported from a dll, set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE,EXTERNAL,DLL,THREAD              ! Exported from a dll, set to the response from the form
VCRRequest           LONG,EXTERNAL,DLL,THREAD              ! Exported from a dll, set to the request from the VCR buttons
FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
LocalErrorStatus     ErrorStatusClass,THREAD
LocalErrors          ErrorClass
LocalINIMgr          INIClass
GlobalErrors         &ErrorClass
INIMgr               &INIClass
DLLInitializer       CLASS                                 ! An object of this type is used to initialize the dll, it is created in the generated bc module
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

  CODE
DLLInitializer.Construct PROCEDURE


  CODE
  LocalErrors.Init(LocalErrorStatus)
  LocalINIMgr.Init('.\other.INI', NVD_INI)                 ! Initialize the local INI manager to use windows INI file
  INIMgr &= LocalINIMgr
  IF GlobalErrors &= NULL
    GlobalErrors &= LocalErrors                            ! Assign local managers to global managers
  END
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  
!These procedures are used to initialize the DLL. It must be called by the main executable when it starts up
other:Init PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>)
other:Init_Called    BYTE,STATIC

  CODE
  IF other:Init_Called
     RETURN
  ELSE
     other:Init_Called = True
  END
  IF ~curGlobalErrors &= NULL
    GlobalErrors &= curGlobalErrors
  END
  IF ~curINIMgr &= NULL
    INIMgr &= curINIMgr
  END
  Access:WAGES.SetErrors(GlobalErrors)

!This procedure is used to shutdown the DLL. It must be called by the main executable before it closes down

other:Kill PROCEDURE
other:Kill_Called    BYTE,STATIC

  CODE
  IF other:Kill_Called
     RETURN
  ELSE
     other:Kill_Called = True
  END
  

DLLInitializer.Destruct PROCEDURE

  CODE
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher
  LocalINIMgr.Kill                                         ! Kill local managers and assign NULL to global refernces
  INIMgr &= NULL                                           ! It is an error to reference these object after this point
  GlobalErrors &= NULL


