

   MEMBER('other.clw')                                     ! This is a MEMBER module


   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('OTHER002.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Update the WAGES File
!!! </summary>
UpdateWAGES PROCEDURE 

CurrentTab           STRING(80)                            ! 
FilesOpened          BYTE                                  ! 
ActionMessage        CSTRING(40)                           ! 
History::wag:Record  LIKE(wag:RECORD),THREAD
QuickWindow          WINDOW('Update the WAGES File'),AT(,,193,112),FONT('MS Sans Serif',8),RESIZE,GRAY,IMM,MDI, |
  HLP('UpdateWAGES'),SYSTEM
                       SHEET,AT(4,4,185,86),USE(?CurrentTab)
                         TAB('General'),USE(?Tab:1)
                           PROMPT('Wages ID:'),AT(8,20),USE(?wag:WagesID:Prompt)
                           ENTRY(@n-14),AT(61,20,64,10),USE(wag:WagesID),RIGHT(1)
                           PROMPT('&Employee:'),AT(8,34),USE(?wag:Employee:Prompt)
                           ENTRY(@s30),AT(61,34,124,10),USE(wag:Employee)
                           PROMPT('&Department:'),AT(8,48),USE(?wag:Department:Prompt)
                           ENTRY(@s30),AT(61,48,124,10),USE(wag:Department)
                           PROMPT('&Salary:'),AT(8,62),USE(?wag:Salary:Prompt)
                           ENTRY(@N12.2),AT(61,62,52,10),USE(wag:Salary)
                           PROMPT('Other:'),AT(8,76),USE(?wag:Other:Prompt)
                           ENTRY(@s21),AT(61,76,88,10),USE(wag:Other)
                         END
                       END
                       BUTTON('OK'),AT(46,94,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(95,94,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(144,94,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a WAGES Record'
  OF ChangeRecord
    ActionMessage = 'Changing a WAGES Record'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateWAGES')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?wag:WagesID:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(wag:Record,History::wag:Record)
  SELF.AddHistoryField(?wag:WagesID,1)
  SELF.AddHistoryField(?wag:Employee,2)
  SELF.AddHistoryField(?wag:Department,3)
  SELF.AddHistoryField(?wag:Salary,4)
  SELF.AddHistoryField(?wag:Other,5)
  SELF.AddUpdateFile(Access:WAGES)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:WAGES.Open()                                      ! File WAGES used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:WAGES
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateWAGES',QuickWindow)                  ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:WAGES.Close()
  END
  IF SELF.Opened
    INIMgr.Update('UpdateWAGES',QuickWindow)               ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update()
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

